BricsCAD: Text entlang eines Kreisbogens anordnen (Software)

Martin Vogel ⌂ @, Dortmund / Bochum, Donnerstag, 09. April 2015, 21:40 (vor 1140 Tagen)

Ganz tief unten in meinem Archiv habe ich ein uraltes Lisp-Programm gefunden, um „runden Text“ mit AutoCAD oder BricsCAD zu schreiben. Viel Spaß damit!

[image]ZIP-Archiv_27E9IVVC1.zip

  1. ; Copyright (c) 1988, 2015 by Martin Vogel
  2. ; Eine Textzeile wird entlang eines
  3. ; Kreisbogens dargestellt.
  4.  
  5. (defun C:RUND (/ s sl m r sw ew bw x th)
  6. (setvar "CMDECHO" 0)
  7. (setq sl (strlen (setq s (getstring "\nText: " t))))
  8. (setq th (getreal "\nTexthoehe: "))
  9. (setq m (getpoint "\nMittelpunkt: "));
  10. (setq r (getdist m "\nRadius des Inkreises: "))
  11. (setq sw (getangle m "\nStartwinkel: "))
  12. (setq ew (getangle m "\nEndwinkel: "))
  13. ; Winkel pro Buchstabe
  14. (setq bw (/ (- ew sw) (1- sl)))
  15. ; Index des aktuellen Buchstabens
  16. (setq x 1)
  17. ; Wenn Endwinkel kleiner Startwinkel:
  18. ; Text wird im Gegenuhrzeigersinn geschrieben,
  19. ; dazu Radius um Texthöhe vergrößern.
  20. (if (< ew sw) (setq kw 90)
  21. (progn (setq kw 270) (setq r (+ r th))))
  22. (setq sw (- sw bw))
  23. ; Schleife über alle Buchstaben
  24. (while (<= x sl)
  25. ; BricsCAD
  26. (Command "TEXT" "MP"
  27. ; AutoCAD
  28. ; (Command "TEXT" "Z"
  29. (polar m (setq sw (+ sw bw)) r)
  30. th
  31. (- (/ (* 180 sw) PI) kw)
  32. (substr s x 1))
  33. (setq x (1+ x)))
  34. )

--
Dipl.-Ing. Martin Vogel
Leiter des Bauforums

Heute schon programmiert? Einführung in Python 3 (PDF)



gesamter Thread:

 RSS-Feed dieser Diskussion

powered by my little forum